package com.framsticks.core;

import javax.annotation.Nonnull;
import javax.annotation.concurrent.Immutable;

import com.framsticks.params.CompositeParam;
import com.framsticks.params.ParamBuilder;

/**
 * @author Piotr Sniegowski
 */
@Immutable
public class Node {

	protected final CompositeParam param;
	protected final Object object;
	//protected final Map<String, Node> children = new HashMap<String, Node>();

	public Node() {
		param = null;
		object = null;
	}

	public Node(@Nonnull CompositeParam param, Object object) {
		assert param != null;
		this.param = param;
		this.object = object;
	}

	public Node(@Nonnull ParamBuilder builder, Object object) {
		this((CompositeParam) builder.finish(), object);
	}

	public final CompositeParam getParam() {
		return param;
	}

	public final Object getObject() {
		return object;
	}

}
