package com.framsticks.params;

import java.util.ArrayList;
import java.util.List;

import com.framsticks.params.annotations.FramsClassAnnotation;
import com.framsticks.params.annotations.ParamAnnotation;

/**
 * @author Piotr Sniegowski
 */
@FramsClassAnnotation
public class Group {

	@ParamAnnotation
	protected String name;

	/**
	 * Group members.
	 */
	List<Param> params = new ArrayList<Param>();

	public Group(String name) {
		this.name = name;
	}

	/**
	 * Adds new group member.
	 *
	 * @param p the new group member
	 */
	void addProperty(Param p) {
		params.add(p);
	}

	/**
	 * Gets the property.
	 *
	 * @param i the i
	 * @return the property
	 */
	Param getProperty(int i) {
		if (i < 0 || i >= params.size())
			return null;
		return params.get(i);
	}

	@Override
	public String toString() {
		return name;
	}

	/**
	 * @return the name
	 */
	@ParamAnnotation
	public String getName() {
		return name;
	}

}
